// MJPEG Screensaver
//
// Copyright (C) 2007 Andrew Hamilton
// hamiltona@mchsi.com
//
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//
// The method to retrieve and parse the MJPEG stream
// is used from the excellent software:
// Camara Vision
//
// Copyright  Andrew Kirillov, 2005-2006
// andrew.kirillov@gmail.com
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MjpegScreensaver
{
    /// <summary>
    /// Summary description for Options.
    /// </summary>
    public class frmOptions : System.Windows.Forms.Form
    {
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.ComboBox combo_streams;
        private System.Windows.Forms.GroupBox groupBox2;
        private System.Windows.Forms.GroupBox groupBox3;
        private System.Windows.Forms.Label lbl_bgColor;
        private System.Windows.Forms.Button btn_bgColor;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;
        private System.Windows.Forms.Button btn_cancel;
        private System.Windows.Forms.Button btn_ok;
        private TextBox textBox1;
        private GroupBox groupBox4;
        private ComboBox combo_method;
        private RichTextBox richTextBox1;
        private Button about_button;
        Options o;

        public frmOptions()
        {

            InitializeComponent();
            o = new Options();
            //o.ReadOptionsFromFile();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.combo_streams = new System.Windows.Forms.ComboBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.btn_bgColor = new System.Windows.Forms.Button();
            this.lbl_bgColor = new System.Windows.Forms.Label();
            this.btn_cancel = new System.Windows.Forms.Button();
            this.btn_ok = new System.Windows.Forms.Button();
            this.groupBox4 = new System.Windows.Forms.GroupBox();
            this.combo_method = new System.Windows.Forms.ComboBox();
            this.richTextBox1 = new System.Windows.Forms.RichTextBox();
            this.about_button = new System.Windows.Forms.Button();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox4.SuspendLayout();
            this.SuspendLayout();
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.combo_streams);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(152, 48);
            this.groupBox1.TabIndex = 0;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Number of Steams";
            // 
            // combo_streams
            // 
            this.combo_streams.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.combo_streams.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4"});
            this.combo_streams.Location = new System.Drawing.Point(8, 16);
            this.combo_streams.Name = "combo_streams";
            this.combo_streams.Size = new System.Drawing.Size(136, 21);
            this.combo_streams.TabIndex = 0;
            this.combo_streams.SelectedIndexChanged += new System.EventHandler(this.combo_speed_SelectedIndexChanged);
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.textBox1);
            this.groupBox2.Location = new System.Drawing.Point(8, 64);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(336, 48);
            this.groupBox2.TabIndex = 1;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Stream URLs";
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(8, 18);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(320, 20);
            this.textBox1.TabIndex = 0;
            this.textBox1.Text = "<URL #1>;<URL #2>;<URL #3>;...";
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.btn_bgColor);
            this.groupBox3.Controls.Add(this.lbl_bgColor);
            this.groupBox3.Location = new System.Drawing.Point(176, 8);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(168, 48);
            this.groupBox3.TabIndex = 2;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "Background Color";
            // 
            // btn_bgColor
            // 
            this.btn_bgColor.Location = new System.Drawing.Point(96, 19);
            this.btn_bgColor.Name = "btn_bgColor";
            this.btn_bgColor.Size = new System.Drawing.Size(64, 23);
            this.btn_bgColor.TabIndex = 1;
            this.btn_bgColor.Text = "Change";
            this.btn_bgColor.Click += new System.EventHandler(this.btn_bgColor_Click);
            // 
            // lbl_bgColor
            // 
            this.lbl_bgColor.Dock = System.Windows.Forms.DockStyle.Fill;
            this.lbl_bgColor.Location = new System.Drawing.Point(3, 16);
            this.lbl_bgColor.Name = "lbl_bgColor";
            this.lbl_bgColor.Size = new System.Drawing.Size(162, 29);
            this.lbl_bgColor.TabIndex = 0;
            // 
            // btn_cancel
            // 
            this.btn_cancel.Location = new System.Drawing.Point(350, 41);
            this.btn_cancel.Name = "btn_cancel";
            this.btn_cancel.Size = new System.Drawing.Size(91, 23);
            this.btn_cancel.TabIndex = 4;
            this.btn_cancel.Text = "Cancel";
            this.btn_cancel.Click += new System.EventHandler(this.btn_cancel_Click);
            // 
            // btn_ok
            // 
            this.btn_ok.Location = new System.Drawing.Point(350, 12);
            this.btn_ok.Name = "btn_ok";
            this.btn_ok.Size = new System.Drawing.Size(91, 23);
            this.btn_ok.TabIndex = 5;
            this.btn_ok.Text = "OK";
            this.btn_ok.Click += new System.EventHandler(this.btn_ok_Click);
            // 
            // groupBox4
            // 
            this.groupBox4.Controls.Add(this.combo_method);
            this.groupBox4.Location = new System.Drawing.Point(8, 118);
            this.groupBox4.Name = "groupBox4";
            this.groupBox4.Size = new System.Drawing.Size(152, 48);
            this.groupBox4.TabIndex = 6;
            this.groupBox4.TabStop = false;
            this.groupBox4.Text = "Display Method";
            // 
            // combo_method
            // 
            this.combo_method.FormattingEnabled = true;
            this.combo_method.Items.AddRange(new object[] {
            "Scale Image",
            "Center Image"});
            this.combo_method.Location = new System.Drawing.Point(23, 19);
            this.combo_method.Name = "combo_method";
            this.combo_method.Size = new System.Drawing.Size(121, 21);
            this.combo_method.TabIndex = 0;
            // 
            // richTextBox1
            // 
            this.richTextBox1.ForeColor = System.Drawing.Color.Red;
            this.richTextBox1.Location = new System.Drawing.Point(176, 118);
            this.richTextBox1.Name = "richTextBox1";
            this.richTextBox1.ReadOnly = true;
            this.richTextBox1.Size = new System.Drawing.Size(168, 48);
            this.richTextBox1.TabIndex = 8;
            this.richTextBox1.Text = "Warning: If your monitor is subject to \"burn-in\", use this screensaver at your ow" +
                "n risk!";
            // 
            // about_button
            // 
            this.about_button.Location = new System.Drawing.Point(350, 89);
            this.about_button.Name = "about_button";
            this.about_button.Size = new System.Drawing.Size(91, 23);
            this.about_button.TabIndex = 9;
            this.about_button.Text = "About";
            this.about_button.UseVisualStyleBackColor = true;
            this.about_button.Click += new System.EventHandler(this.about_button_Click);
            // 
            // frmOptions
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(449, 178);
            this.Controls.Add(this.about_button);
            this.Controls.Add(this.richTextBox1);
            this.Controls.Add(this.groupBox4);
            this.Controls.Add(this.btn_ok);
            this.Controls.Add(this.btn_cancel);
            this.Controls.Add(this.groupBox3);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Name = "frmOptions";
            this.Text = "Screensaver Options";
            this.Load += new System.EventHandler(this.Options_Load);
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.groupBox3.ResumeLayout(false);
            this.groupBox4.ResumeLayout(false);
            this.ResumeLayout(false);

        }
        #endregion

        private void btn_bgColor_Click(object sender, System.EventArgs e)
        {
            ColorDialog dlg = new ColorDialog();
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                lbl_bgColor.BackColor = dlg.Color;
            }
        }

        private void Options_Load(object sender, System.EventArgs e)
        {
            Options op = new Options();
            op = op.ReadOptionsFromFile();
            this.combo_method.SelectedIndex = op.Scale;
            this.combo_streams.SelectedIndex = op.Streams;
            this.textBox1.Text = op.Text;
            this.lbl_bgColor.BackColor = ColorTranslator.FromHtml(op.BgColor);
            //this.lbl_foreColor.BackColor = ColorTranslator.FromHtml(op.ForeColor);


        }

        private void btn_ok_Click(object sender, System.EventArgs e)
		{
			o.Streams = combo_streams.SelectedIndex;
            o.Scale = combo_method.SelectedIndex;
			o.BgColor = ColorTranslator.ToHtml(lbl_bgColor.BackColor);
            o.Text = textBox1.Text;
            o.Url = textBox1.Text.Split(';');

			System.Xml.Serialization.XmlSerializer ser = new System.Xml.Serialization.XmlSerializer(typeof(Options));
			System.IO.StreamWriter wr = new System.IO.StreamWriter(Options.options_path);
			ser.Serialize(wr, o);

			wr.Flush();
			wr.Close();

			this.Close();
		}

        private void btn_cancel_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }

        private void combo_speed_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (combo_streams.SelectedIndex == 0)
                combo_method.Enabled = true;
            else
                combo_method.Enabled = false;
        }

        private void about_button_Click(object sender, EventArgs e)
        {
            const string message =
                "MJPEG Screensaver, Version 0.01\n\tCopyright  Andrew Hamilton, 2007\n" +
                "\thamiltona@mchsi.com\n" +
                "\tThis part of the software is released under the MIT software license:\n" + 
                "\thttp://www.opensource.org/licenses/mit-license.php\n\n" +
                "MJPEG Parsing Routine, Used With Permission\n\tCopyright  Andrew Kirillov, 2005-2006\n" +
                "\tandrew.kirillov@gmail.com\n" +
                "\thttp://www.codeproject.com/cs/media/cameraviewer.asp\n";

            MessageBox.Show(message, "About MJPEG Screensaver",
                MessageBoxButtons.OK, MessageBoxIcon.None);
        }
    }
}
